(function() {

    var QWeb = openerp.web.qweb;
    openerp.widgetInstanceAdvancement = null;
    openerp.PayslipAdvancement = {};

    openerp.PayslipAdvancement = openerp.Widget.extend({
        template: 'payslip_add.AdvancementWidget',
        id: undefined,
        uid: undefined,
        row_id_select: undefined,
        row_code_select: undefined,
        hrPayslip: [],
        payslipLine: [],
        salaryRule: [],
        resCompany: [],
        resCurrency: [],
        payslipInput: [],
        /* init */
        init: function (parent) {
            this._super(parent);
            this.uid = parent.session.uid;
        },
        /* Start */
        start: function () {
            var self = this;
            var addAdvancement = this.$el.find('.add-advancement');
            var editAdvancement = this.$el.find('.edit-advancement');
            var refreshAdvancement = this.$el.find('.refresh-advancement');
            var printAdvancement = this.$el.find('.print-advancement');
            // create
            addAdvancement.click(function() {
                self.fetchAddAdvancement();
            });
            // Edit/ unlink
            editAdvancement.click(function() {
                self.fetchModifyAdvancement();
            });
            // Update
            refreshAdvancement.click(function() {
                self.fetchRecomputeSheet();
            });
            // Imprimir Adelanto y comision
            printAdvancement.click(function() {
                self.fetchPrintAdvancement();
            });
        },
        /* Actualizar ID */
        updateIdAdvancement: function(id) {
            var self = this;
            self.id = id;
        },
        /* Description: Recargar el Widget */
        reloadLine: function() {
            openerp.parentInstance.reload();
        },
        /* Description: Función para recalcular las faltas */
        recomputeSheet: function() {
             var self = this;
             var defer = $.Deferred();
             var recomputePayslip = new openerp.web.Model('hr.payslip');

             recomputePayslip.call('recompute_sheet',[ self.id ], {
                     context: new openerp.web.CompoundContext()
             }).then(function(results) {
                 defer.resolve(results);
             });

             return defer;
         },
        /* Description: Función para remover el modal */
        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },
        /* Description: Consultar Compania*/
        fetchResCompany: function () {
            var resComapy = new openerp.web.Model('res.company');
            return resComapy.query(['id','name', 'currency_id']).filter([['id', '=', 1]]).all();
        },
        /* Description: Consultat Moneda Activas */
        fetchResCurrecy : function() {
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
            var domain = [['active', '=', true]];
            var resCurrecy = new openerp.web.Model('res.currency');
            return resCurrecy.query(fields).filter(domain).all();
        },
        /* Description: Filtar moneda de la compania */
        getCurrencyCompany: function(id) {
            var self = this;
            return _.filter(self.resCurrency, function(item) {
                return item.id === id;
            });
         },
        /* Description: destroy objects*/
        destroyObjects: function() {
            var self = this;
            self.row_id_select = undefined;
            self.row_code_select = undefined;
            self.hrPayslip = [];
            self.payslipLine = [];
            self.salaryRule = [];
            self.resCompany = [];
            self.resCurrency = [];
            self.payslipInput =[];
        },
        /* ---------------------------------------------------------------------
        ** Description : Crear Adealnto/ comision de Funcionario
        ** -------------------------------------------------------------------*/
        /* Description: Funcion Inicial Crear Comicion/Adelanto */
        fetchAddAdvancement: function() {
            var self = this;
            self.fetchPayslip().then(function(hrPayslip) {
                return hrPayslip;
            }).then(function(hrPayslip) {
                self.hrPayslip = hrPayslip;
                return self.fetchPayslipLine();
            }).then(function(payslipLine) {
                self.payslipLine = payslipLine;
                return self.fetchSalaryRule();
            }).then(function(salaryRule) {
                self.salaryRule = salaryRule;
                return self.fetchResCompany();
            }).then(function(resCompany) {
                self.resCompany = resCompany;
                return self.fetchResCurrecy();
            }).then(function(resCurrency) {
                self.resCurrency = resCurrency;
                return self.showPayslipAddAdvancement();
            }).then(function() {
                return self.recomputeSheet();
            }).then(function() {
                return self.reloadLine();
            }).then(function() {
                return self.destroyObjects();
            });
        },
        /* Description : Consultar Payslip */
        fetchPayslip: function() {
            var self = this;
            var payslip = new openerp.web.Model('hr.payslip');
            return payslip.query(['name', 'employee_id', 'number','date_from','date_to']).filter([['id', '=', self.id]]).all();
        },
        /* Description: Consultar payslip Line (hr.payslip.line) */
        fetchPayslipLine: function() {
            var self = this;
            var fields = ['id', 'name', 'code', 'slip_id', 'amount', 'employee_id'];
            var domain = [['code', '=', 'NET'],['slip_id', '=', self.id]];
            var payslipLine = new openerp.web.Model('hr.payslip.line');
            return payslipLine.query(fields).filter(domain).all();
        },
        /* Description: Consulta Reglas Salarial (ADL CMS)*/
        fetchSalaryRule: function() {
            var salaryRule = new openerp.web.Model('hr.salary.rule');
            return salaryRule.query(['name','code']).filter([['code','in',['ADL','CMS']]]).all();
        },
        /* Description: Modal crear Adealnto/ comision de Funcionario */
        showPayslipAddAdvancement: function() {
            var self = this;
            var payslipLine = self.payslipLine.shift();
            var hrPayslip = self.hrPayslip.shift();
            var defer = $.Deferred()
            var company = self.resCompany.shift();
            var currency = self.getCurrencyCompany(company.currency_id[0]).shift();
            var amount_Adl = 0;
            var employeData = [
                {
                    'employe_name': hrPayslip.employee_id[1],
                    'salari': accounting.formatMoney(payslipLine.amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator)
                }
            ];
            var modalAdvancement = QWeb.render('EiruPayslipAddAdvancement',{
                employeData: employeData,
                salaryRule: self.salaryRule
            });

            $('.openerp_webclient_container').after(modalAdvancement);
            $('.expired-account-modal').modal();

            /* Close modal */
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                defer.resolve(true);
                self.removeModal(e);
            });

            var salary_rule = $('.expired-account-modal').find('.salary-rule');
            var details = $('.expired-account-modal').find('.advancement-details');
            var ammount_input = $('.expired-account-modal').find('.advancement-amount');
            var addAdvancement = $('.expired-account-modal').find('.add-advancement');

            addAdvancement.click(function(e){
                /* Operacion */
                var amount = parseInt(accounting.unformat(ammount_input.val(),','));
                if (!salary_rule.val()) {
                    openerp.web.notification.do_warn("Atención","Seleccione el tipo de operación.");
                    salary_rule.css('border-color','red');
                    return;
                }
                salary_rule.css('border-color','#ccc');
                /* Detalles */
                if (!details.val()) {
                    openerp.web.notification.do_warn("Atención","Defina una descripción para la operación.");
                    details.css('border-color','red');
                    return;
                }
                details.css('border-color','#ccc');
                /* Importe */
                if (amount <= 0) {
                    openerp.web.notification.do_warn("Atención","El importe de la operación no debe ser  meno o igual 0 (cero).");
                    ammount_input.css('border-color','red');
                    return;
                }
                ammount_input.css('border-color','#ccc');
                var payslip = new openerp.web.Model('hr.payslip');
                if (amount > payslipLine.amount && salary_rule.val() === "ADL"){
                    openerp.web.notification.do_warn("Atención","El importe del adelanto no puede superar el dueldo neto,\n Importe permitido "+ accounting.formatMoney(payslipLine.amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
                    ammount_input.focus();
                    return;
                }

                if (salary_rule.val() === "ADL") {
                    amount = (amount * -1);
                }

                payslip.call('create_payslip_input',
                [
                    {
                        id: self.id,
                        salary_rule: salary_rule.val(),
                        details: details.val(),
                        ammount_input: amount
                    }
                ],{
                    context: new openerp.web.CompoundContext()
                }).then(function(results) {
                    defer.resolve(results)
                });
                self.removeModal(e);
            });
            ammount_input.keyup(function() {
                amount_Adl = parseInt(accounting.unformat( ammount_input.val(),','));
                ammount_input.val(accounting.formatMoney((amount_Adl), currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
            });

            return defer;
        },
        /* ---------------------------------------------------------------------
        ** Description: Recalcular Nominas
        ** -------------------------------------------------------------------*/
        fetchRecomputeSheet: function() {
            var self = this;
            self.$el.find('.refresh-advancement').attr("disabled", true);
            self.recomputeSheet().then(function(results) {
                return results;
            }).then(function() {
                self.$el.find('.refresh-advancement').removeAttr("disabled");
                self.reloadLine();
            });
        },
        /* ---------------------------------------------------------------------
        ** Description: Editar/Remover Faltas
        ** -------------------------------------------------------------------*/
        /* Description: Funcion  Inicial Modify/Unlink Faltas*/
        fetchModifyAdvancement: function() {
            var self = this;
            self.fetchPayslipInput().then(function(payslipInput) {
                return payslipInput;
            }).then(function(payslipInput) {
                self.payslipInput = payslipInput;
                return self.fetchSalaryRule();
            }).then(function(salaryRule) {
                self.salaryRule = salaryRule;
                return self.joinInputSalari();
            }).then(function(inputSalari) {
                self.inputSalari = inputSalari;
                return self.fetchPayslipLine();
            }).then(function(payslipLine) {
                self.payslipLine =payslipLine;
                return self.fetchPayslip();
            }).then(function(hrPayslip) {
                self.hrPayslip = hrPayslip;
                return self.fetchResCompany();
            }).then(function(resCompany) {
                self.resCompany = resCompany;
                return self.fetchResCurrecy();
            }).then(function(resCurrency) {
                self.resCurrency = resCurrency;
                return self.showModifyAdvancement();
            }).then(function() {
                return self.destroyObjects();
            });
        },
        /* Description: COnsultar Payslip Input (hr.payslip.input)*/
        fetchPayslipInput: function() {
            var self = this;
            var fields = ['id','name', 'code', 'amount','create_date'];
            var domain = [['payslip_id', '=', self.id]];
            var hrPayslipInput = new openerp.web.Model('hr.payslip.input');
            return hrPayslipInput.query(fields).filter(domain).all();
         },
        /* Description: Unir payslip_input con salary_rule*/
        joinInputSalari: function() {
            var self = this;
            var defer = $.Deferred();
            var inputSalari = [];
            var rule;

            _.each(self.payslipInput, function(item) {
                rule = self.getSalaryRule(item.code).shift();
                if (!rule){
                    rule = {};
                    rule.name= item.code;
                }
                var amount = item.amount;
                if (item.code === 'ADL'){
                    amount = (item.amount * -1);
                }

                inputSalari.push(
                    {
                        'id': item.id,
                        'name': item.name,
                        'code': item.code,
                        'amount': amount,
                        'input_name': rule.name
                    }
                );
            });
            defer.resolve(inputSalari);
            return defer;
         },
        /* Description : Filtar Salary_rule por code*/
        getSalaryRule: function(code) {
            var self = this;
             return _.filter(self.salaryRule, function(filter) {
                 return filter.code === code;
             });
         },
        /* Description: Modal para la Modificacion de Adelanto y faltas*/
        showModifyAdvancement: function() {
            var self = this;
            var defer = $.Deferred();
            var row_modify;
            var payslipLine = self.payslipLine.shift();
            var hrPayslip = self.hrPayslip.shift();
            var company = self.resCompany.shift();
            var currency = self.getCurrencyCompany(company.currency_id[0]).shift();
            var amountSelect = 0;
            var amount_Adl = 0;

            if (self.inputSalari.length === 0) {
                openerp.web.notification.do_warn("Atención","No existe registro  para modificar");
                return;
            }
            var employeData = [{
                    employe_name: hrPayslip.employee_id[1],
                    salari: accounting.formatMoney(payslipLine.amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator)
            }];
            var inputSalari = [];
            _.each(self.inputSalari, function(item) {
                inputSalari.push(
                    {
                        'id': item.id,
                        'name': item.name,
                        'code': item.code,
                        'amount': accounting.formatMoney(item.amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator),
                        'input_name': item.input_name
                    }
                )
            });
            var modalModifyAdvancement = QWeb.render('EiruPayslipModifyAdvancement', {
                inputData: inputSalari,
                employeData: employeData
            });
            $('.openerp_webclient_container').after(modalModifyAdvancement);
            $('.expired-account-modal').modal();

            var descript_input = $('.expired-account-modal').find('.advancement-details-modify');
            var amount_input = $('.expired-account-modal').find('.advancement-amount-modify');
            var buttonUpdate = $('.expired-account-modal').find('.modify-advancement');
            var unlinkAdvancement = $('.expired-account-modal').find('.unlink-advancement');
            var tableRow = $('.expired-account-modal').find('.table-tbody').find('tr');
            buttonUpdate.attr("disabled", true);
            /* Salir*/
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                defer.resolve('salir');
                self.removeModal(e);
            });
            /* Seleccionar  fila */
            tableRow.click(function (e) {
                row_modify = $(e.target);
                if (($(e.target).index() === 5) || ($(e.target).index() === 0))
                    return;

                tableRow.removeClass('table-row-select');
                $(e.target).closest('tr').addClass('table-row-select');
                /* Cargar Campo Description y importe */
                descript_input.val(($(e.target).closest('tr').children()[3].textContent).trim());
                amountSelect = parseInt(accounting.unformat($(e.target).closest('tr').children()[4].textContent ,',' ));
                amount_input.val(accounting.formatMoney((amountSelect), currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
                // Actualizar el Id de elemento seleccionado
                self.row_id_select = parseInt($(e.target).closest('tr').children()[0].textContent);
                self.row_code_select = ($(e.target).closest('tr').children()[1].textContent).trim();
                // Habilitar botón modificar
                buttonUpdate.removeAttr("disabled");
                descript_input.focus();
            });
            /* Click botón Modificar */
            buttonUpdate.click(function() {
                var amount = parseInt(accounting.unformat(amount_input.val(),','));
                if (!descript_input.val()) {
                   openerp.web.notification.do_warn("Atención","Definir un motivo de la falta .");
                   descript_input.css('border-color','red');
                   descript_input.focus();
                   return;
                }
                descript_input.css('border-color','#ccc');
                if (amount <= 0) {
                    openerp.web.notification.do_warn("Atención","Días no trabajado, debe ser mayor que 0.");
                    amount_input.css('border-color','red');
                    amount_input.focus();
                    return;
                }
                var neto = accounting.unformat($('.expired-account-modal').find('.number').val(), ',');

                if (amount > (neto + amountSelect) && self.row_code_select === 'ADL') {
                    openerp.web.notification.do_warn("Atención","El importe del adelanto no puede superar el sueldo neto.\n Importe permitido "+accounting.formatMoney(neto + amountSelect, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
                    amount_input.css('border-color','red');
                    amount_input.focus();
                    return;
                }
                    amount_input.css('border-color','#ccc');
                /* Actualizar Adelanto / comision */
                self.writePayslipAdvancement(descript_input.val(), amount ).then(function(results){
                    return results;
                }).then(function() {
                    return self.recomputeSheet();
                }).then(function() {
                    return self.reloadLine();
                }).then(function() {
                    return self.fetchPayslipLine();
                }).then(function(payslipLine) {
                    self.payslipLine = payslipLine;
                    payslipLine = payslipLine.shift();
                    $('.expired-account-modal').find('.number').val(accounting.formatMoney(payslipLine.amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
                    defer.resolve(payslipLine);
                });
                row_modify.closest('tr').children()[3].textContent = descript_input.val();
                row_modify.closest('tr').children()[4].textContent =  accounting.formatMoney(amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator);

                descript_input.val("");
                amount_input.val(0);
                amountSelect = 0;
                buttonUpdate.attr("disabled", true);
           });
           /* Click boton Unlink/ Eliminar */
           unlinkAdvancement.click(function(e) {
                var unlink_row = parseInt($(e.target).closest('td').closest('tr').children()[0].textContent);
                var unlink_code =$(e.target).closest('td').closest('tr').children()[1].textContent;
                var unlink_amount = parseInt(accounting.unformat($(e.target).closest('tr').children()[4].textContent ,',' ));
                var neto = accounting.unformat($('.expired-account-modal').find('.number').val(), ',');

                if (unlink_amount > neto && unlink_code === 'CMS'){
                    openerp.web.notification.do_warn("Atención"," No podes eliminar una comisión con el  el importe mayor al sueldo neto.\n Sueldo neto actual "+accounting.formatMoney(neto, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
                    return;
                }

                self.unlinkPayslipAdvancement(unlink_row).then(function(results) {
                    return results;
                }).then(function() {
                    return self.recomputeSheet();
                }).then(function() {
                    return self.reloadLine();
                }).then(function() {
                    return self.fetchPayslipLine();
                }).then(function(payslipLine) {
                    self.payslipLine = payslipLine;
                    payslipLine = payslipLine.shift();
                    $('.expired-account-modal').find('.number').val(accounting.formatMoney(payslipLine.amount, currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
                    defer.resolve(payslipLine);
                });
                $(e.target).closest('td').closest('tr').remove();
           });
           /* Keyup */
           amount_input.keyup(function() {
               amount_Adl = parseInt(accounting.unformat(amount_input.val(), ','));
               amount_input.val(accounting.formatMoney((amount_Adl), currency.symbol,currency.decimal_places, currency.thousands_separator, currency.decimal_separator));
           });
            return defer;
        },
        /* Description: Funcion para Actualizar Adlanto / comision*/
        writePayslipAdvancement: function(description, amount_input) {
            var self = this;
            var defer = $.Deferred();
            var payslip = new openerp.web.Model('hr.payslip')
            var amount = amount_input;
            if (self.row_code_select === "ADL")
                amount = (amount_input * -1);

            payslip.call('write_payslip_input', [
                {
                    'id': self.id,
                    'input_id': self.row_id_select,
                    'descript_input': description,
                    'amount_input': amount
                }
            ], {
                context : new openerp.web.CompoundContext()
            }).then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },
        /* Description: Eliminar Adelanto /comision*/
        unlinkPayslipAdvancement: function(input_id) {
            var self = this;
            var defer = $.Deferred();
            var  payslip = new openerp.web.Model('hr.payslip');
            payslip.call('unlink_payslip_input',[{
                'id': self.id,
                'input_id': input_id
            }], {
                context: new openerp.web.CompoundContext()
            }).then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        /* ---------------------------------------------------------------------
         * Description : Imprimir adelanto y comisión de funcionario
         * -------------------------------------------------------------------*/
        /* Description : Metodo Inicial de imprecion */
        fetchPrintAdvancement: function() {
            var self = this;
            self.fetchPayslip().then(function(hrPayslip) {
                return hrPayslip;
            }).then(function(hrPayslip) {
                self.hrPayslip = hrPayslip;
                return self.fetchPayslipInput();
            }).then(function(payslipInput) {
                self.payslipInput = payslipInput;
                return self.fetchResCompany();
            }).then(function(resCompany) {
                self.resCompany = resCompany;
                return self.fetchResCurrecy();
            }).then(function(resCurrency) {
                self.resCurrency = resCurrency;
                return self.fetchResUser();
            }).then(function(resUser){
                self.resUser = resUser;
                return self.fetchSalaryRule();
            }).then(function(salaryRule) {
                self.salaryRule = salaryRule;
                return self.jsPdfPrintAdvancement();
            });
                //
        },
        /* Consultar Usuario (res.User) */
        fetchResUser: function() {
            var self = this;
            var resUser = new openerp.web.Model('res.users');
            return resUser.query(['name']).filter([['active', '=', true],['id', '=', self.uid]]).all();
        },
        /* Filtar Adelantos */
        getpayslipInput: function() {
            var self = this;
            return _.filter(self.payslipInput, function(item) {
                return item.code === "ADL";
            });

        },
        /* Generar la impresion de Adelanto */
        jsPdfPrintAdvancement: function() {
            var self = this;
            var payslipInput = self.getpayslipInput();

            if (payslipInput.length === 0){
                openerp.web.notification.do_warn("Atención","El funcionario no cuenta con adelantos registrado");
                return;
            }
            var inputBody = [];
            var inputHead = [
                {
                    title : 'Tipo de operación',
                    dataKey : 'code_name'
                },
                {
                    title : 'Descripción',
                    dataKey : 'input_name'
                },
                {
                    title : 'Importe',
                    dataKey : 'amount_input'
                },
                {
                    title : 'Fecha de operación',
                    dataKey : 'date'
                },
            ];
            var salaryRule;
            var company = self.resCompany.shift();
            var currency = self.getCurrencyCompany(company.currency_id[0]).shift();

            _.each(payslipInput, function(input) {
                salaryRule = self.getSalaryRule(input.code).shift();
                if (!salaryRule){
                    salaryRule ={};
                    salaryRule.name="N/A";
                }
                inputBody.push({
                    code_name :  salaryRule.name,
                    input_name: input.name,
                    amount_input: accounting.formatNumber((-1 * input.amount), currency.decimal_places, currency.thousands_separator, currency.decimal_separator),
                    amount: (-1 * input.amount),
                    date: moment(input.create_date).format('DD/MM/YYYY')
                });
            });
            /* sumar los importe*/
            var total = _.reduce(_.map(inputBody, function(map) {
                return map.amount;
            }),function(memo, num){
                return memo + num;
            }, 0);

            inputBody.push({
                code_name :  "",
                input_name: 'Total' ,
                amount_input: accounting.formatNumber(total, currency.decimal_places, currency.thousands_separator, currency.decimal_separator),
                amount: total,
                date: ""
            });
            self.drawPDF(inputHead, inputBody, total, currency);
        },
        /* Generar el pdf*/
        drawPDF: function(inputHead, inputBody, total, currency) {
            var self = this;
            var hrPayslip = self.hrPayslip.shift();
            var resUser = self.resUser.shift();
            var pdfDoc = new jsPDF();
            /* titulo */
            pdfDoc.setFontType('bold');
            pdfDoc.setFontSize(18);
            pdfDoc.text(105, 20, "RECIBO DE ADELANTO", null, null, 'center');
            /* Subtitulos*/
            pdfDoc.setFontType('bold');
            pdfDoc.setFontSize(12);
            pdfDoc.text(20, 30, "Funcionario: ");
            pdfDoc.text(20, 40, "Referencia: ");
            pdfDoc.text(120, 40, "Periodo: ");
            /* Detalles */
            pdfDoc.setFontType('normal');
            pdfDoc.setFontSize(12);
            pdfDoc.text(50, 30, hrPayslip.employee_id[1]);
            pdfDoc.text(50, 40, hrPayslip.number);
            pdfDoc.text(150, 40, moment(hrPayslip.date_from).format('DD/MM/YYYY')+" - "+moment(hrPayslip.date_to).format('DD/MM/YYYY'));
            /* Tabla */
            pdfDoc.autoTable(inputHead, inputBody, {
                margin: {
                    top: 50,
                    horizontal: 7
                },
                styles: { overflow: 'linebreak', fontSize: 10, columnWidth: 'wrap'},
                columnStyles: {
                    code_name: {columnWidth: 35},
                    input_name: {columnWidth: 'auto'},
                    amount_input: {columnWidth: 30, halign:'right'},
                    date: {columnWidth: 40, halign:'center'},
                },
            });
            var first = pdfDoc.autoTable.previous;
            var fila = first.finalY;
            var moneda = self.getNameCurrency(currency.name);
            /*Final de la pagina*/
            fila = fila + 20;
            pdfDoc.setFontType('bold');
            pdfDoc.setFontSize(12);
            pdfDoc.text(10, fila, "TOTAL EN LETRAS ");

            pdfDoc.setFontType('normal');
            pdfDoc.setFontSize(12);
            pdfDoc.text(50, fila, moneda+": "+openerp.web.num2word(total));

            fila = fila + 20;
            pdfDoc.setFontType('bold');
            pdfDoc.setFontSize(10);
            pdfDoc.text(10, fila, "Firma ......................................");
            pdfDoc.text(150, fila, "Firma ......................................");

            fila = fila + 5;
            pdfDoc.text(10, fila,resUser.name);
            pdfDoc.text(150, fila, hrPayslip.employee_id[1] );
            /* Guardar */
            pdfDoc.save('RECIBO DE ADELANTO de'+hrPayslip.employee_id[1]+'.pdf');

        },
        /* Obtener el nombre de la moneda */
        getNameCurrency: function(code) {
            var moneda = "";
            if (code === 'PYG') {
                moneda ="GUARANÍES"
            }
            if (code === 'USD') {
                moneda ="DÓLARES AMERICANOS "
            }
            return moneda
        }
    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'hr.payslip')
                    return;

                if (this.$el.find('.oe_form_sheet.oe_form_sheet_width').closest('.modal-content.openerp').length !== 0)
                    return;

                openerp.parentInstance = this;
                if (openerp.widgetInstanceAdvancement) {
                    openerp.widgetInstanceAdvancement.updateIdAdvancement(record.id);
                }

                if (this.$el.find('.payslip-add-advancement').length !== 0 )
                    return;

                openerp.widgetInstanceAdvancement = new openerp.PayslipAdvancement(this);

                var elemento = this.$el.find('.oe_notebook_page');
                elemento = elemento.find('.payslip-utility-add-advancement');

                openerp.widgetInstanceAdvancement.appendTo(elemento);
                openerp.widgetInstanceAdvancement.updateIdAdvancement(record.id);
            }
        });
    }
})();
